#!/bin/csh
set working_directory = `pwd`
#
set start = $3
#
set target      = `grep thresh_refine mparameters_run | awk '{print $2}'`
set thresh      = `grep thresh_reconst mparameters_run | awk '{print $2}'`
set pbc         = `grep PBC mparameters_run | awk '{print $2}'`
set boff        = `grep BOFF mparameters_run | awk '{print $2}'`
set dang        = `grep DANG mparameters_run | awk '{print $2}'`
set itmax       = `grep ITMAX mparameters_run | awk '{print $2}'`
set mode        = `grep MODE mparameters_run | awk '{print $2}'`
set fpart       = `grep FPART mparameters_run | awk '{print $2}'`
set dfstd       = `grep DFSTD mparameters_run | awk '{print $2}'`
set rrec        = `grep res_reconstruction mparameters_run | awk '{print $2}'`
set rref        = `grep res_refinement mparameters_run | awk '{print $2}'`
set rlowref     = `grep res_low_refinement mparameters_run | awk '{print $2}'`
set data_input  = `grep data_input mparameters_run | awk '{print $2}'`
set raw_images  = `grep raw_images mparameters_run | awk '{print $2}'`
set pixel_s     = `grep pixel_size mparameters_run | awk '{print $2}'`
set dstep       = `grep dstep mparameters_run | awk '{print $2}'`
set w_gh        = `grep WGH mparameters_run | awk '{print $2}'`
set kV1         = `grep kV1 mparameters_run | awk '{print $2}'`
set cs          = `grep Cs mparameters_run | awk '{print $2}'`
set xstd        = `grep XSTD mparameters_run | awk '{print $2}'`
set fmag        = `grep FMAG mparameters_run | awk '{print $2}'`
set fdef        = `grep FDEF mparameters_run | awk '{print $2}'`
set fastig      = `grep FASTIG mparameters_run | awk '{print $2}'`
set rbfact      = `grep RBFACT mparameters_run | awk '{print $2}'`
set iewald      = `grep IEWALD mparameters_run | awk '{print $2}'`
set asym        = `grep ASYM mparameters_run | awk '{print $2}'`
set alpha       = `grep ALPHA mparameters_run | awk '{print $2}'`
set rise        = `grep RISE mparameters_run | awk '{print $2}'`
set nsubunits   = `grep NSUBUNITS mparameters_run | awk '{print $2}'`
set nstarts     = `grep NSTARTS mparameters_run | awk '{print $2}'`
set stiffness   = `grep STIFFNESS mparameters_run | awk '{print $2}'`
set FBEAUT      = `grep FBEAUT mparameters_run | awk '{print $2}'`
set FCREF       = `grep FCREF mparameters_run | awk '{print $2}'`
set ro          = `grep ROUT mparameters_run | awk '{print $2}'`
set ri          = `grep RIN mparameters_run | awk '{print $2}'`

set SCRATCH = ${working_directory}/../scratch

@ prev = $start - 1
cd $SCRATCH

#cp ${working_directory}/${data_input}_${prev}.par ${data_input}_${prev}.par_$1_$2
cp ${working_directory}/${data_input}_${prev}.spi ${data_input}_${start}.spi_$1_$2
\rm ${data_input}_${start}.par_${1}_${2} >& /dev/null

time ${working_directory}/../../bin/frealign_v8.exe << eot >& ${data_input}_mrefine_n.log_${1}_${2}
S,1,${fmag},${fdef},${fastig},${fpart},${iewald},${FBEAUT},${FCREF},F,0,F,1		!CFORM,IFLAG,FMAG,FDEF,FASTIG,FPART,IEWALD,FBEAUT,FCREF,FMATCH,IFSC,FSTAT,IBLOW
${ro},${ri},${pixel_s},${w_gh},${xstd},${pbc},${boff},${dang},${itmax},10		!RO,RI,PSIZE,WGH,XSTD,PBC,BOFF,DANG,ITMAX,IPMAX
1 1 1 1 1										!MASK
${1},${2}										!IFIRST,ILAST 
${asym}											!ASYM symmetry card
${alpha},${rise},${nsubunits},${nstarts},${stiffness}					!ALPHA,RISE,#SUBUNITS,#STARTS,STIFFNESS
1.0, ${dstep}, ${target}, ${thresh}, ${cs}, ${kV1}, 0., 0.				!RELMAG,DSTEP,TARGET,THRESH,CS,AKV,TX,TY
${rrec},${rlowref},${rref},${dfstd},${rbfact}						!RREC,RMAX1,RMAX2,DFSTD,RBFACT
${working_directory}/${raw_images}.spi
${data_input}_${start}_match.spi_${1}_${2}
temp.par
${data_input}_${start}.par_${1}_${2}
${data_input}_${start}.shft_${1}_${2}
0., 0., 0., 0., 0., 0., 0., 0.								!terminator with RELMAG=-100.0 to skip 3D reconstruction
${data_input}_${start}.spi_$1_$2
${data_input}_${start}_weights_${1}_${2}
${data_input}_${start}_qfactor_${1}_${2}
${data_input}_${start}_amplitudes_${1}_${2}
${data_input}_${start}_phasediffs_${1}_${2}
${data_input}_${start}_pointspread_${1}_${2}
eot
#
echo Job on $HOST finished >> $SCRATCH/stderr
#
