#!/bin/csh
#unlimit
limit coredumpsize 0
set working_directory = `pwd`
set SCRATCH = ../scratch

set start = $3
set radius      = `grep radius mparameters_run | awk '{print $2}'`
set target      = `grep thresh_refine mparameters_run | awk '{print $2}'`
set thresh      = `grep thresh_reconst mparameters_run | awk '{print $2}'`
set pbc         = `grep PBC mparameters_run | awk '{print $2}'`
set boff        = `grep BOFF mparameters_run | awk '{print $2}'`
set dang        = `grep DANG mparameters_run | awk '{print $2}'`
set itmax       = `grep ITMAX mparameters_run | awk '{print $2}'`
set mode        = `grep MODE mparameters_run | awk '{print $2}'`
set fpart       = `grep FPART mparameters_run | awk '{print $2}'`
set dfsig       = `grep dfsig mparameters_run | awk '{print $2}'`
set rrec        = `grep res_reconstruction mparameters_run | awk '{print $2}'`
set rref        = `grep res_refinement mparameters_run | awk '{print $2}'`
set rlowref     = `grep res_low_refinement mparameters_run | awk '{print $2}'`
set data_input  = `grep data_input mparameters_run | awk '{print $2}'`
set raw_images1 = `grep raw_images1 mparameters_run | awk '{print $2}'`
set pixel_s     = `grep pixel_size mparameters_run | awk '{print $2}'`
set dstep       = `grep dstep mparameters_run | awk '{print $2}'`
set w_gh        = `grep WGH mparameters_run | awk '{print $2}'`
set kV1         = `grep kV1 mparameters_run | awk '{print $2}'`
set cs          = `grep CS mparameters_run | awk '{print $2}'`
set xstd        = `grep XSTD mparameters_run | awk '{print $2}'`
set fmag        = `grep FMAG mparameters_run | awk '{print $2}'`
set fdef        = `grep FDEF mparameters_run | awk '{print $2}'`
set fastig      = `grep FASTIG mparameters_run | awk '{print $2}'`
set rbfact      = `grep RBFACT mparameters_run | awk '{print $2}'`
set iewald      = `grep IEWALD mparameters_run | awk '{print $2}'`

@ prev = $start - 1
cd $SCRATCH

#cp ${working_directory}/../${data_input}_${prev}.mrc ${data_input}_${start}.mrc_$1_$2
\rm ${data_input}.par_${1}_${2} >& /dev/null
\rm ${data_input}.shft_${1}_${2} >& /dev/null

time ../../bin/frealign_v8.exe << eot >& ${data_input}_msearch_n.log_${1}_${2}
M,${mode},${fmag},${fdef},${fastig},${fpart},${iewald},F,F,F,0,F,4	!CFORM,IFLAG,FMAG,FDEF,FASTIG,FPART,IEWALD,FBEAUT,FCREF,FMATCH,IFSC,FSTAT,IBLOW
${radius},0.,${pixel_s},${w_gh},${xstd},${pbc},0.0,${dang},${itmax},10	!RO,RI,PSIZE,WGH,XSTD,PBC,BOFF,DANG,ITMAX,IPMAX
1 1 1 1 1								!MASK
${1},${2}								!IFIRST,ILAST 
0
1.0, ${dstep}, ${target}, ${thresh}, ${cs}, ${kV1}, 0., 0.		!RELMAG,DSTEP,TARGET,THRESH,CS,AKV,TX,TY
${rrec},${rlowref},${rref},${dfsig},${rbfact}				!RREC,RMAX1,RMAX2,DFSIG,RBFACT
${working_directory}/../${raw_images1}.mrc
${data_input}_match.mrc_${1}_${2}
200,45000.,926,18500,18500,45.,0					!NIN,ABSMAGPIN,IFILMIN,DFMID1IN,DFMID2IN,ANGASTIN,MORE
${data_input}.par_${1}_${2}
${data_input}.shft_${1}_${2}
-100., 0., 0., 0., 0., 0., 0., 0.					!terminator with RELMAG=-100.0 to skip 3D reconstruction
${working_directory}/../${data_input}_${prev}.mrc
${data_input}_weights_${start}_${1}_${2}
${data_input}_map1_${1}_${2}
${data_input}_map2_${1}_${2}
${data_input}_phasediffs_${1}_${2}
${data_input}_pointspread_${1}_${2}
eot
#
