C**************************************************************************
      SUBROUTINE MASK3D(NSAM,A3DV,RIO,RIC,HALFW)
C**************************************************************************
C Applies spherical mask with outer radius RIO, inner radius RIC, and
C cosine edge.
C Used in Frealign.
C**************************************************************************
      IMPLICIT NONE

      INTEGER L,M,N,NSAM,ID
      INTEGER I,J,K,NBG
      REAL A3DV(*),BG,XC,YC,ZC,XL,YM,ZN,RM,RIO
      REAL RAD,RAD2,HALFW,RI,RII,RIH,RI2,EDGE,PI,RI3,RIC
      PARAMETER  (PI=3.1415926535897)
C**************************************************************************
      RI=RIO
C
      RM=MIN(RI,FLOAT(NSAM/2)-1.0-HALFW/2.0)
      RII=RM+HALFW/2.0
      RIH=RM-HALFW/2.0
      IF (RIH.LT.0.0) RIH=0.0
      RI2=RIH**2
      RI3=RII**2
      BG=0.0
      NBG=0
      XC=1.0 + 0.5*FLOAT(NSAM)
      YC=XC
      ZC=XC
      DO 50 L=1,NSAM
      	XL=L-XC
      	DO 50 M=1,NSAM
      	  YM=M-YC
      	  DO 50 N=1,NSAM
      	    ZN=N-ZC
      	    ID=L+NSAM*((M-1)+NSAM*(N-1))
      	    RAD2=XL**2+YM**2+ZN**2
      	    IF ((RAD2.GT.RI2).AND.(RAD2.LT.RI3)) THEN
              BG=BG+A3DV(ID)
              NBG=NBG+1
            ENDIF
50    CONTINUE
      IF (NBG.NE.0) BG=BG/NBG
C
      DO 51 L=1,NSAM
      	XL=L-XC
      	DO 51 M=1,NSAM
      	  YM=M-YC
      	  DO 51 N=1,NSAM
      	    ZN=N-ZC
      	    ID=L+NSAM*((M-1)+NSAM*(N-1))
      	    RAD2=XL**2+YM**2+ZN**2
      	    IF(RAD2.LE.RI2) GOTO 51
      	    RAD=SQRT(RAD2)
      	    IF(RAD.GT.RIH.AND.RAD.LT.RII) THEN
      	      EDGE=(1.0+COS(PI*(RAD-RIH)/HALFW))/2.0
      	    ELSE
      	      EDGE=0.0
      	    ENDIF
      	    A3DV(ID)=A3DV(ID)*EDGE+BG*(1.0-EDGE)
51    CONTINUE
C
      IF (RIC.GT.0.0) THEN
C
      RI=RIC
C
      RM=MAX(RI,HALFW/2.0)
      RII=RM+HALFW/2.0
      RIH=RM-HALFW/2.0
      RI2=RIH**2
      RI3=RII**2
      BG=0.0
      NBG=0
      DO 60 L=1,NSAM
      	XL=L-XC
      	DO 60 M=1,NSAM
      	  YM=M-YC
      	  DO 60 N=1,NSAM
      	    ZN=N-ZC
      	    ID=L+NSAM*((M-1)+NSAM*(N-1))
      	    RAD2=XL**2+YM**2+ZN**2
      	    IF ((RAD2.GT.RI2).AND.(RAD2.LT.RI3)) THEN
              BG=BG+A3DV(ID)
              NBG=NBG+1
            ENDIF
60    CONTINUE
      IF (NBG.NE.0) BG=BG/NBG
C
      DO 61 L=1,NSAM
      	XL=L-XC
      	DO 61 M=1,NSAM
      	  YM=M-YC
      	  DO 61 N=1,NSAM
      	    ZN=N-ZC
      	    ID=L+NSAM*((M-1)+NSAM*(N-1))
      	    RAD2=XL**2+YM**2+ZN**2
      	    IF(RAD2.GE.RI3) GOTO 61
      	    RAD=SQRT(RAD2)
      	    IF(RAD.GT.RIH.AND.RAD.LT.RII) THEN
      	      EDGE=(1.0+COS(PI*(RII-RAD)/HALFW))/2.0
      	    ELSE
      	      EDGE=0.0
      	    ENDIF
      	    A3DV(ID)=A3DV(ID)*EDGE+BG*(1.0-EDGE)
61    CONTINUE
C
      ENDIF
C
      RETURN
      END
