C ------------------------------------------------------------------------	
	SUBROUTINE MATCH(K,NSAM,IRADA,OUTC,OUTD,OUTQ,C3DF,C3DS,
     +               PHI,THETA,PSI,JC,NSAMH,PHASE,SHX,SHY,
     +		     DSHX,DSHY,NN1,XSTD,RI,B3DV,MBUF,ICMP,DATA,
     +		     SPEC,SPEQ,CCPART,PRESA,PRESAOLD,THRESH,
     +		     CFORM,MAXSET,ILIST,IFIRST,NSET,IOPROJ,
     +		     SINCLUT,IPAD,THETATR,IEWALD,
     +               CTFF,CTFS,PSIZE)
C ------------------------------------------------------------------------	
C         Output of matching projections if requested
C	  CALL MASKENV,rlft3,SHIFT, PEXTRACT, STAMP and IWRITE.
C	  Used in LMAIN.
C ------------------------------------------------------------------------	
        IMPLICIT NONE
        REAL PI,FRAD
	PARAMETER  (PI=3.1415926535897,FRAD=20.0)

	INTEGER NN1,NSAM,NSAM1,IRADA,IOPROJ,N1,IDD,ID,IP
        INTEGER ILIST,IFIRST,I,II,J,JJ,ICMP,K,NSET
        INTEGER MAXSET,IPAD,NSAMH,JC

        REAL CCPART,RI,XSTD,DSTD,OSTD
	REAL DATA(*),OUTD(*),PSIZE
	REAL B3DV(*),DSHX,DSHY,RAD2
	REAL PSI,THETA,PHI,MBUF(*)
	REAL SHX,SHY,PRESA,PRESAOLD,THRESH(*)
	DOUBLE PRECISION SINCLUT(*),PHASE
	COMPLEX OUTC(*),OUTQ(*),SPEQ(*)
	COMPLEX C3DF(*),C3DS(*),SPEC(*)
        CHARACTER*1 CFORM
C MW added parameters for PEXTRACTE (Ewald sphere correction)
C        REAL CS,WL,WGH1,WGH2,DFMID1,DFMID2,ANGAST,
        COMPLEX CTFF(*),CTFS(*)
        REAL THETATR
        INTEGER IEWALD
C ------------------------------------------------------------------------	
        write(*,6405) PSI*180./PI,THETA*180./PI,PHI*180./PI
6405    format(' values of PSI,THETA,PHI at FMATCH extraction',3F9.3)

        CALL PEXTRACT(NSAM,IRADA,OUTC,OUTQ,C3DF,C3DS,PHI,THETA,PSI,
     +			SINCLUT,IPAD,THETATR,IEWALD,CTFF,CTFS)

        CALL SHIFT2D(JC,NSAM,NSAMH,0.0,0.0,0.0,0.0,OUTC,OUTQ,NN1)

        OUTC(1)=CMPLX(0.0,0.0)
C
        CALL RLFT3(OUTD,OUTQ,NSAM,NSAM,1,-1)

        IF (XSTD.LT.0.0) CALL MASKENV(NSAM,RI,OUTD,B3DV,
     +          SHX+DSHX,SHY+DSHY,PHI,THETA,PSI,MBUF,0)

C           WRITE OUT PROJECTION
            N1=3.0*RI/ICMP
            IF (N1*ICMP.GT.NSAM) N1=NSAM/ICMP
            CALL SHIFT2D(JC,NSAM,NSAMH,-SHX-DSHX,-SHY-DSHY,
     +                   PI,PI,DATA,SPEQ,NN1)
C
C     Low-pass filter....
        DO 88 I=1,JC
          II=I-1
          DO 88 J=1,NSAM
            JJ=J-1
            IF (JJ.GE.JC) JJ=JJ-NSAM
              RAD2=REAL(II**2+JJ**2)/NSAM**2/PSIZE**2*FRAD**2
              IF (I.NE.JC) THEN
                ID=I+NSAMH*(J-1)
                SPEC(ID)=SPEC(ID)*EXP(-RAD2)
              ELSE
                SPEQ(I)=SPEQ(I)*EXP(-RAD2)
              ENDIF
88      CONTINUE
C
            CALL RLFT3(DATA,SPEQ,NSAM,NSAM,1,-1)
            CALL WINDOW(NSAM,N1*ICMP,DATA,DSTD)
            CALL WINDOW(NSAM,N1*ICMP,OUTD,OSTD)

            DO 22 I=1,N1
              DO 22 II=1,N1
                DO 22 J=0,ICMP-1
                  DO 22 JJ=0,ICMP-1
                    ID=II+N1*(I-1)
                    IDD=1+ICMP*(II-1)+J+N1*ICMP*(ICMP*(I-1)+JJ)
                    OUTD(ID)=OUTD(IDD)/NSAM/NSAM*2/ICMP**2
     +                       /OSTD*DSTD
22          CONTINUE

            DO 24 I=1,N1
              DO 24 II=1,N1
                DO 24 J=0,ICMP-1
                  DO 24 JJ=0,ICMP-1
                    IDD=1+ICMP*(II-1)+J+N1*ICMP*(ICMP*(I-1)+JJ)
                    ID=II+N1*(I-1+N1)
                    OUTD(ID)=DATA(IDD)/NSAM/NSAM*2/ICMP**2
24          CONTINUE

            CALL STAMP(REAL(K),6,0,OUTD,N1,2*N1,N1-23,
     +                 2*N1-5,CFORM)
C            CALL STAMP(PSI/PI*180.0,5,2,OUTD,N1,2*N1,1,
C     +                 N1+1,CFORM)
C            CALL STAMP(THETA/PI*180.0,5,2,OUTD,N1,2*N1,23,
C     +                 N1+1,CFORM)
C            CALL STAMP(PHI/PI*180.0,5,2,OUTD,N1,2*N1,45,
C     +                 N1+1,CFORM)
            CALL STAMP(PRESA/PI*180.0,7,2,OUTD,N1,2*N1,
     +                 1,N1,CFORM)
C            CALL STAMP(CCPART,6,1,OUTD,N1,2*N1,
C     +                 1,N1-5,CFORM)
            CALL STAMP((PRESA-PRESAOLD)/PI*180.0,6,2,OUTD,N1,
     +                 2*N1,1,N1-5,CFORM)

            IF (PRESA.GT.ABS(THRESH(NSET))) THEN
              CALL STAMP(0.0,1,1,OUTD,N1,2*N1,1,2*N1-5,CFORM)
            ENDIF

C           IP=2*N1*(ABS(ILIST)-1)
            IP=2*N1*(K-IFIRST)
            NSAM1=2*N1

            DO 23 I=1,2*N1
              ID=1+N1*(I-1)
              CALL IWRITE(IOPROJ,OUTD(ID),I+IP)
23          CONTINUE

	RETURN
	END
