C**************************************************************************
      SUBROUTINE PINC(NSET,THRESH,PRESA,NANG1,NANG)
C**************************************************************************
C     Determines the phase residual threshold to exclude a given
C     percentage of particles
C     Used in card10
C**************************************************************************
      IMPLICIT NONE
C
      INTEGER NSET,NANG1,NANG,I,J,N
      REAL THRESH(*),PRESA(*),T,P,PI,C
      PARAMETER (PI=3.1415926535897)
C
      C=1.0/100.0/180.0*PI
      DO 20 J=1,9000
        N=0
        T=REAL(J)*C
        DO 10 I=NANG1+1,NANG
          IF (PRESA(I).LT.T) N=N+1
10      CONTINUE
        P=REAL(N)/REAL(NANG-NANG1)
        IF (P.GT.ABS(THRESH(NSET))) GOTO 30
20    CONTINUE
C
30    CONTINUE
      IF (N.EQ.0) THEN
        STOP ' ****ERROR**** all particles excluded in data set'
      ELSE
        T=T*180.0/PI
        IF (J.EQ.1) THEN
          T=90.0
          P=1.0
        ENDIF
        WRITE(*,1000)NSET,P*100.0,N,T
1000    FORMAT(/,' NSET =',I3,': percentage included = ',F7.2,
     +         /,'            particles included = ',I7,
     +         /,'            threshold set to   ',F10.2,/)
      ENDIF
      THRESH(NSET)=T
C
      RETURN
      END
