C**************************************************************************
      SUBROUTINE PINSERT(NSAM,IRAD,RI,RREC,AMAG,SPEC,SPEQ,CTFF,
     +		   CTFS,A3DF,A3DS,S3DF,S3DS,B3DF,B3DS,T3DF,T3DS,
     +		   TTD,PHI,THETA,PSI,SHX,SHY,PRESA,PBC,BOFF,
     +		   ASUM,VSUM,PSUM,C3DF,KSUM,ISIGN,SINCLUT,IRADA,
     +             IPAD,THET,IEWALD,C3DS,NSYM,ISYM,
     +             JSYM,SYMOP,NNSTAT,NKSUM,IMP)
C**************************************************************************
C  Adds an image transform into the accumulating 3D transform and also 
C  accumulates the CTF**2 for use in later normalisation.
C  Uses PINSERT_S.
C  Used in A3D3.
C**************************************************************************
      IMPLICIT NONE

      INTEGER NSAM,JC,I,J,IRAD,IC,IEWALD
      INTEGER L,ISIGN,NSAMH,ID,IS,IRREC,IRREC2,NSYM,IMP
      INTEGER KSUM(*),IPAD,IRADA,ISYM(*),JSYM(*),NNSTAT
      INTEGER*8 NKSUM,NKSUM1
      REAL DM(9),SHX,SHY,RREC,TLIM,TM(9),SYMOP(3,3,*)
      REAL CTFV2,CTFV2S2,S3DF(*),CPHI,SPHI,RI,ST
      REAL CTHE,STHE,CPSI,SPSI,PHI,THETA,PSI
      REAL PHASE,PBC,BOFF,WGT,PI,TMP,AMAG
      REAL S3DS(*),RII,PREF,T3DF(*),T3DS(*),PRESA
      REAL VSUM(*),PSUM(*),ASUM(*),SINCLUT(*),THET
      DOUBLEPRECISION TTD,TTD1
      PARAMETER (PI=3.1415926535897)
      PARAMETER (TLIM=2.0)
      COMPLEX SAMP,SPEC(*),SPEQ(*),BSAMP,CTFF(*),CTFS(*)
      COMPLEX A3DF(*),A3DS(*),B3DF(*),B3DS(*)
      COMPLEX C3DF(*),C3DS(*)
C**************************************************************************
      	PREF=PBC/180.0*PI
        JC=NSAM/2+1
        IC=NSAM*NSAM/2
      	NSAMH=NSAM/2
      	RII=2.0*PI*RI/NSAM
      	IRREC=INT(REAL(NSAM)*RREC)
      	IF (IRREC.GT.NSAMH) IRREC=NSAMH
      	IRREC2=IRREC**2
        CPHI=COS(PHI)
        SPHI=SIN(PHI)
        CTHE=COS(THETA)
        STHE=SIN(THETA)
        CPSI=COS(PSI)
        SPSI=SIN(PSI)
c      PRINT *,PRESA*180.0/PI,PBC,BOFF/PBC,-(PRESA/PREF-BOFF/PBC)
      	TMP=-(PRESA/PREF-BOFF/PBC)
        IF (TMP.GT.TLIM) THEN
      	  TMP=TLIM
C      	  PRINT *,'TLIM IN ACTION!!!!!'
      	ENDIF
      	TMP=TMP/REAL(NSAMH)**2
C      	WGT=EXP(-PRESA/PREF)

        TM(1)=(CPHI*CTHE*CPSI-SPHI*SPSI)/ABS(AMAG)
        TM(2)=(SPHI*CTHE*CPSI+CPHI*SPSI)/ABS(AMAG)
        TM(3)=-STHE*CPSI/ABS(AMAG)
        TM(4)=(-CPHI*CTHE*SPSI-SPHI*CPSI)/ABS(AMAG)
        TM(5)=(-SPHI*CTHE*SPSI+CPHI*CPSI)/ABS(AMAG)
        TM(6)=STHE*SPSI/ABS(AMAG)
        TM(7)=STHE*CPHI/ABS(AMAG)
        TM(8)=STHE*SPHI/ABS(AMAG)
        TM(9)=CTHE/ABS(AMAG)
C
      	IF (ISIGN.LT.0) THEN
      	  DO 10 L=1,NSAM
      	    DO 10 J=1,NSAM
      	      IS=J+NSAM*(L-1)
      	      B3DS(IS)=A3DS(IS)
c      	      T3DS(IS)=S3DS(IS)
      	      DO 10 I=1,NSAM/2
      	        ID=I+NSAMH*((J-1)+NSAM*(L-1))
      	        B3DF(ID)=A3DF(ID)
c      	        T3DF(ID)=S3DF(ID)
10	  CONTINUE
      	ENDIF
C
        DO 940 I=1,NSYM
          ISYM(I)=1
940     CONTINUE
C
900     CONTINUE
C
        DO 910 I=1,9
          DM(I)=TM(I)
910     CONTINUE
        DO 920 I=1,NSYM
          IF (ISYM(I).NE.JSYM(I)) THEN
            DO 930 J=1,ISYM(I)
              CALL MATMUL_T(DM,SYMOP(1,1,I),DM)
930         CONTINUE
          ENDIF
920     CONTINUE
C
        ST=REAL(2*JC-1)/REAL(IMP)
        NKSUM1=0
        TTD1=0.0D0
!$OMP PARALLEL DO REDUCTION(+:NKSUM1,TTD1)
        DO 20 I=1,IMP
          CALL PINSERT_S(NSAM,IRAD,RII,IRREC2,SPEC,SPEQ,CTFF,
     +             CTFS,B3DF,B3DS,T3DF,T3DS,TTD1,SHX,SHY,
     +             ASUM,VSUM,PSUM,C3DF,KSUM,ISIGN,SINCLUT,IRADA,
     +             IPAD,THET,IEWALD,C3DS,NNSTAT,NKSUM1,JC,DM,
     +             TMP,NSAMH,IC,0.0,0.0,ST,I)
20      CONTINUE
        NKSUM=NKSUM+NKSUM1
        TTD=TTD+TTD1
C
        I=1
990     CONTINUE
        ISYM(I)=ISYM(I)+1
        IF (ISYM(I).GT.JSYM(I)) THEN
          ISYM(I)=1
          I=I+1
          IF (I.LE.NSYM) GOTO 990
        ELSE
          I=1
          GOTO 900
        ENDIF
C
      	RETURN
      	END
