C**************************************************************************
      SUBROUTINE PINSERT_C(NSAM,IRAD,RI,RREC,AMAG,SPEC,SPEQ,CTFF,
     +		   CTFS,A3DF,A3DS,S3DF,S3DS,B3DF,B3DS,T3DF,T3DS,
     +		   TTD,PHI,THETA,PSI,SHX,SHY,PRESA,PBC,BOFF,
     +		   ASUM,VSUM,PSUM,C3DF,KSUM,ISIGN,SINCLUT,IRADA,
     +             IPAD,THET,IEWALD,C3DS,NSYM,ISYM,
     +             JSYM,SYMOP,NNSTAT,NKSUM,IMP,PSIZE,ALPHA,RISE,
     +             NU,HSTART)
C**************************************************************************
C  Adds an image transform into the accumulating 3D transform and also 
C  accumulates the CTF**2 for use in later normalisation.
C  Uses PINSERT_S.
C  Used in A3D3.
C**************************************************************************
      IMPLICIT NONE

      INTEGER NSAM,JC,I,J,IRAD,IC,IEWALD,K,HSTART
      INTEGER L,ISIGN,NSAMH,ID,IS,IRREC,IRREC2,NSYM,IMP
      INTEGER KSUM(*),IPAD,IRADA,ISYM(*),JSYM(*),NNSTAT
      INTEGER K1,K2,NU,N1,N2
      INTEGER*8 NKSUM,NKSUM1
      REAL DM(9),SHX,SHY,RREC,TLIM,TM(9),SYMOP(3,3,*)
      REAL CTFV2,CTFV2S2,S3DF(*),CPHI,SPHI,RI,ST
      REAL CTHE,STHE,CPSI,SPSI,PHI,THETA,PSI,SCW(9)
      REAL PHASE,PBC,BOFF,WGT,PI,TMP,AMAG
      REAL S3DS(*),RII,PREF,T3DF(*),T3DS(*),PRESA
      REAL VSUM(*),PSUM(*),ASUM(*),SINCLUT(*),THET
      REAL ALPHA,RISE,A,DX,DY,PSIZE,D,DS,ALPHAS
      DOUBLEPRECISION TTD,TTD1
      PARAMETER (PI=3.1415926535897)
      PARAMETER (TLIM=2.0)
      COMPLEX SAMP,SPEC(*),SPEQ(*),BSAMP,CTFF(*),CTFS(*)
      COMPLEX A3DF(*),A3DS(*),B3DF(*),B3DS(*)
      COMPLEX C3DF(*),C3DS(*)
C**************************************************************************
      PREF=PBC/180.0*PI
      JC=NSAM/2+1
      IC=NSAM*NSAM/2
      NSAMH=NSAM/2
      RII=2.0*PI*RI/NSAM
      IRREC=INT(REAL(NSAM)*RREC)
      IF (IRREC.GT.NSAMH) IRREC=NSAMH
      IRREC2=IRREC**2
      CPHI=COS(PHI)
      SPHI=SIN(PHI)
      CTHE=COS(THETA)
      STHE=SIN(THETA)
      CPSI=COS(PSI)
      SPSI=SIN(PSI)
c      PRINT *,PRESA*180.0/PI,PBC,BOFF/PBC,-(PRESA/PREF-BOFF/PBC)
      TMP=-(PRESA/PREF-BOFF/PBC)
      IF (TMP.GT.TLIM) THEN
      	TMP=TLIM
C      	PRINT *,'TLIM IN ACTION!!!!!'
      ENDIF
      TMP=TMP/REAL(NSAMH)**2
C     WGT=EXP(-PRESA/PREF)

      TM(1)=(CPHI*CTHE*CPSI-SPHI*SPSI)/ABS(AMAG)
      TM(2)=(SPHI*CTHE*CPSI+CPHI*SPSI)/ABS(AMAG)
      TM(3)=-STHE*CPSI/ABS(AMAG)
      TM(4)=(-CPHI*CTHE*SPSI-SPHI*CPSI)/ABS(AMAG)
      TM(5)=(-SPHI*CTHE*SPSI+CPHI*CPSI)/ABS(AMAG)
      TM(6)=STHE*SPSI/ABS(AMAG)
      TM(7)=STHE*CPHI/ABS(AMAG)
      TM(8)=STHE*SPHI/ABS(AMAG)
      TM(9)=CTHE/ABS(AMAG)
C
      IF (ISIGN.LT.0) THEN
      	DO 10 L=1,NSAM
      	  DO 10 J=1,NSAM
      	    IS=J+NSAM*(L-1)
      	    B3DS(IS)=A3DS(IS)
c      	    T3DS(IS)=S3DS(IS)
      	    DO 10 I=1,NSAM/2
      	      ID=I+NSAMH*((J-1)+NSAM*(L-1))
      	      B3DF(ID)=A3DF(ID)
c      	      T3DF(ID)=S3DF(ID)
10	CONTINUE
      ENDIF
C
      I=NINT(2.0*PI/ALPHA)
      DS=-I*RISE/HSTART
      ALPHAS=I*ALPHA-2.0*PI
C
      N1=-NINT(NU/2.0)
      N2=NINT(NU/2.0)
      IF (N2-N1+1.GT.NU) N2=N2-1
      IF (N2-N1+1.GT.NU) N1=N1+1
      K1=-NINT(HSTART/2.0)
      K2=NINT(HSTART/2.0)
      IF (K2-K1+1.GT.HSTART) K2=K2-1
      IF (K2-K1+1.GT.HSTART) K1=K1+1
C
      DO 40 J=N1,N2
        DO 40 K=K1,K2
          DO 30 L=1,9
            DM(L)=TM(L)
            SCW(L)=0.0
30        CONTINUE
          A=ALPHA*J+ALPHAS*K
          D=-RISE*J+DS*K
          DX=-D*CPSI*STHE/ABS(AMAG)
          DY=D*SPSI*STHE/ABS(AMAG)
          SCW(9)=1.0
          SCW(1)=COS(A)
          SCW(2)=SIN(A)
          SCW(4)=-SIN(A)
          SCW(5)=COS(A)
          CALL MATMUL_T(DM,SCW,DM)
C
          ST=REAL(2*JC-1)/REAL(IMP)
          NKSUM1=0
          TTD1=0.0D0
!$OMP PARALLEL DO REDUCTION(+:NKSUM1,TTD1)
          DO 20 I=1,IMP
          CALL PINSERT_S(NSAM,IRAD,RII,IRREC2,SPEC,SPEQ,CTFF,
     +             CTFS,B3DF,B3DS,T3DF,T3DS,TTD1,SHX,SHY,
     +             ASUM,VSUM,PSUM,C3DF,KSUM,ISIGN,SINCLUT,IRADA,
     +             IPAD,THET,IEWALD,C3DS,NNSTAT,NKSUM1,JC,DM,
     +             TMP,NSAMH,IC,DX,DY,ST,I)
20        CONTINUE
          NKSUM=NKSUM+NKSUM1
          TTD=TTD+TTD1
C
40    CONTINUE
C
      RETURN
      END
