C**************************************************************************
      SUBROUTINE PINSERT_S(NSAM,IRAD,RII,IRREC2,SPEC,SPEQ,
     +		   CTFF,CTFS,B3DF,B3DS,T3DF,T3DS,TTD,SHX,SHY,
     +		   ASUM,VSUM,PSUM,C3DF,KSUM,ISIGN,SINCLUT,
     +             IRADA,IPAD,THET,IEWALD,C3DS,NNSTAT,
     +             NKSUM,JC,DM,TMP,NSAMH,IC,DX,DY,ST,IP)
C**************************************************************************
C Called by PINSERT, performs main loop
C Uses function PDIFF
C shared: NKSUM,TTD
C**************************************************************************
      IMPLICIT NONE

      INTEGER NSAM,JC,I,J,II,JJ,LS,LT,MS,MT,NS,NT
      INTEGER L,M,N,LL,MM,NN,ISIGN,NSAMH,ID,IS,IRREC2
      INTEGER JRAD2,L2,M2,N2,KSUM(*),ID4,IPAD,IRADA,IC
      INTEGER NNSTAT,IRAD,I1,I2,IP,I3
      INTEGER*8 NKSUM
      REAL X3,Y3,Z3,DM(9),SHX,SHY
      REAL CTFV2,DX,DY
      REAL PHASE,ST
      REAL RII,DELTA,DX2,DY2,DZ2
      REAL T3DF(*),T3DS(*),WGT,PI,TMP,G2,FRAD2
      REAL VSUM(*),PSUM(*),ASUM(*),PDIFF,A
      REAL SINCLUT(*)
      DOUBLEPRECISION TTD
      PARAMETER (PI=3.1415926535897)
      COMPLEX SAMP,SPEC(*),SPEQ(*),CTFF(*),CTFS(*)
      COMPLEX B3DF(*),B3DS(*),C3DF(*),C3DS(*),PSHFT
      INTEGER IEWALD
      REAL THET,XYZ(6),PREL
      INTEGER BEAM
      COMPLEX FOR,FOL,CTFR,CTFL
C**************************************************************************
        I1=-JC+1+(IP-1)*ST
        I3=-JC+IP*ST
        I2=(I1+I3)/2
C
      	DO 30 I=I1,I2
      	  DO 30 J=-JC+1,JC-1
           DO 30 BEAM=1,2                               ! insert both left and right beam if IEWALD
            IF ((IEWALD.EQ.0).AND.(BEAM.EQ.2)) GOTO 30  ! skip 2nd beam if planar insertion
            IF (IEWALD.EQ.0) THEN
      	      X3=DM(1)*I+DM(4)*J                        ! planar insertion
      	      Y3=DM(2)*I+DM(5)*J
      	      Z3=DM(3)*I+DM(6)*J
            ENDIF
      	    G2=I**2+J**2
      	    WGT=EXP(2.0*TMP*G2)
            PHASE=(SHX+DX)*I+(SHY+DY)*J
            PSHFT=CMPLX(COS(PHASE),SIN(PHASE))
      	    IF (I.GE.0) THEN
      	      II=I+1
      	      JJ=J+1
      	      IF (JJ.LT.1) JJ=JJ+NSAM
      	      IF (II.NE.JC) THEN
      		ID=II+NSAMH*(JJ-1)
      		CTFR=CTFF(ID)
      		CTFL=CTFF(ID+IC)
                IF (IEWALD.LT.0) THEN
                  CTFR=CONJG(CTFR)
                  CTFL=CONJG(CTFL)
                ENDIF
                SAMP=SPEC(ID)*PSHFT
                IF (IEWALD.NE.0) THEN 
                  IF (BEAM.EQ.1) THEN
                    CALL EWALDIN (NSAM,IRADA,C3DF,C3DS,SINCLUT,IPAD, ! reference-derived 
     +                    I,J,DM,THET,XYZ,FOR,FOL,SAMP,PREL,IEWALD,  ! structure factors 
     +                    CTFR,CTFL)
                    X3=XYZ(1)
                    Y3=XYZ(2)
                    Z3=XYZ(3)
                    SAMP=FOR                                         ! right beam
                  ELSE
                    X3=XYZ(4)
                    Y3=XYZ(5)
                    Z3=XYZ(6)
                    SAMP=FOL                                         ! left beam
                  ENDIF
                ELSE
                  SAMP=SAMP*(CTFR+CONJG(CTFL))
                ENDIF
      	      ELSE
                CTFR=CTFS(JJ)
                CTFL=CTFS(JJ+NSAM)
                IF (IEWALD.LT.0) THEN
                  CTFR=CONJG(CTFR)
                  CTFL=CONJG(CTFL)
                ENDIF
                SAMP=SPEQ(JJ)*PSHFT
                IF (IEWALD.NE.0) THEN 
                  IF (BEAM.EQ.1) THEN
                    CALL EWALDIN (NSAM,IRADA,C3DF,C3DS,SINCLUT,IPAD, ! outmost pixel
     +                    I,J,DM,THET,XYZ,FOR,FOL,SAMP,PREL,IEWALD,
     +                    CTFR,CTFL)
                    X3=XYZ(1)
                    Y3=XYZ(2)
                    Z3=XYZ(3)
                    SAMP=FOR                                         ! right beam
                  ELSE
                    X3=XYZ(4)
                    Y3=XYZ(5)
                    Z3=XYZ(6)
                    SAMP=FOL                                         ! left beam
                  ENDIF
                ELSE
                  SAMP=SAMP*(CTFR+CONJG(CTFL))
                ENDIF  
              ENDIF
            ELSE
              II=-I+1
              JJ=-J+1
              IF (JJ.LT.1) JJ=JJ+NSAM
              IF (II.NE.JC) THEN
                ID=II+NSAMH*(JJ-1)
       		CTFR=CTFF(ID)
       		CTFL=CTFF(ID+IC)
                IF (IEWALD.LT.0) THEN
                  CTFR=CONJG(CTFR)
                  CTFL=CONJG(CTFL)
                ENDIF
                SAMP=CONJG(SPEC(ID))*PSHFT
                IF (IEWALD.NE.0) THEN 
                  IF (BEAM.EQ.1) THEN
                    CALL EWALDIN (NSAM,IRADA,C3DF,C3DS,SINCLUT,IPAD, ! reference-derived 
     +                    I,J,DM,THET,XYZ,FOR,FOL,SAMP,PREL,IEWALD,  ! structure factors 
     +                    CTFR,CTFL)
                    X3=XYZ(1)
                    Y3=XYZ(2)
                    Z3=XYZ(3)
                    SAMP=FOR                                         ! right beam
                  ELSE
                    X3=XYZ(4)
                    Y3=XYZ(5)
                    Z3=XYZ(6)
                    SAMP=FOL                                         ! left beam
                  ENDIF
                ELSE
                  SAMP=SAMP*(CTFR+CONJG(CTFL))
                ENDIF
     	      ELSE
                CTFR=CTFS(JJ)
                CTFL=CTFS(JJ+NSAM)
                IF (IEWALD.LT.0) THEN
                  CTFR=CONJG(CTFR)
                  CTFL=CONJG(CTFL)
                ENDIF
		SAMP=CONJG(SPEQ(JJ))*PSHFT
                IF (IEWALD.NE.0) THEN 
                  IF (BEAM.EQ.1) THEN
                    CALL EWALDIN (NSAM,IRADA,C3DF,C3DS,SINCLUT,IPAD, ! outmost pixel
     +                    I,J,DM,THET,XYZ,FOR,FOL,SAMP,PREL,IEWALD,
     +                    CTFR,CTFL)
                    X3=XYZ(1)
                    Y3=XYZ(2)
                    Z3=XYZ(3)
                    SAMP=FOR                                         ! right beam,
                  ELSE
                    X3=XYZ(4)
                    Y3=XYZ(5)
                    Z3=XYZ(6)
                    SAMP=FOL                                         ! left beam
                  ENDIF
                ELSE
                  SAMP=SAMP*(CTFR+CONJG(CTFL))
                ENDIF  
      	      ENDIF
      	    ENDIF
      	    CTFV2=0.25*CABS(CTFR+CONJG(CTFL))**2*WGT
            SAMP=SAMP*WGT

            A=X3+0.5-REAL(IRAD-1)/2.0
      	    LS=INT(A)
      	    IF (A.LT.0.0) LS=LS-1
      	    IF (LS.LT.0) LS=0
            A=X3+REAL(IRAD)/2.0
      	    LT=INT(A)
      	    IF (A.LT.0.0) LT=LT-1
      	    IF (LT.GE.JC) LT=JC-1
            A=Y3+0.5-REAL(IRAD-1)/2.0
      	    MS=INT(A)
      	    IF (A.LT.0.0) MS=MS-1
      	    IF (MS.LE.-JC) MS=-JC+1
            A=Y3+REAL(IRAD)/2.0
      	    MT=INT(A)
      	    IF (A.LT.0.0) MT=MT-1
      	    IF (MT.GE.JC) MT=JC-1
            A=Z3+0.5-REAL(IRAD-1)/2.0
      	    NS=INT(A)
      	    IF (A.LT.0.0) NS=NS-1
      	    IF (NS.LE.-JC) NS=-JC+1
            A=Z3+REAL(IRAD)/2.0
      	    NT=INT(A)
      	    IF (A.LT.0.0) NT=NT-1
      	    IF (NT.GE.JC) NT=JC-1
      	    DO 40 L=LS,LT
      	      L2=L**2
      	      DO 40 M=MS,MT
      	        M2=M**2
      		DO 40 N=NS,NT
      	          N2=N**2
C  Do not use box transform (Chuck Sindelar, 26.9.2008)
C      		  boxftv=BOXFT_LUT(arg,SINCLUT)

      		  	JRAD2=L2+M2+N2
      		  	IF (JRAD2.LE.IRREC2) THEN

      	          		LL=L+1
      		  		MM=M+1
      		  		IF (MM.LT.1) MM=MM+NSAM
      		  		NN=N+1
      		  		IF (NN.LT.1) NN=NN+NSAM
C      		  		ctfv2s2=ctfv2*boxftv
C      		  		BSAMP=samp*boxftv
      		  		IF (ISIGN.GT.0) THEN

      		  		  IF (LL.NE.JC) THEN
      		  		    ID=LL+NSAMH*((MM-1)+NSAM*(NN-1))
      		  		    ID4=IPAD*(LL-1)+1+IPAD*NSAMH*((MM-1)
     .                                  +IPAD*NSAM*(NN-1))
      		  		    B3DF(ID)=B3DF(ID)+SAMP
      		  		    T3DF(ID)=T3DF(ID)+CTFV2
                                    NKSUM=NKSUM+1
                                    IF (NNSTAT.NE.0) THEN
                                      KSUM(ID)=KSUM(ID)+1
                                      VSUM(ID)=VSUM(ID)+CABS(SAMP)**2
				      PSUM(ID)=PSUM(ID)
     .                                       +PDIFF(SAMP,C3DF(ID4))
                                      ASUM(ID)=ASUM(ID)+CABS(SAMP)
                                    ENDIF
      		  		  ELSE
      		  		    IS=MM+NSAM*(NN-1)
      		  		    B3DS(IS)=B3DS(IS)+SAMP
      		  		    T3DS(IS)=T3DS(IS)+CTFV2
      		  		  ENDIF
      		  		  TTD=TTD+CTFV2

      		  		ELSE

      		  		  IF (LL.NE.JC) THEN
      		  		    ID=LL+NSAMH*((MM-1)+NSAM*(NN-1))
      		  		    B3DF(ID)=B3DF(ID)-SAMP
c      		  		    T3DF(ID)=T3DF(ID)-CTFV2
      		  		  ELSE
      		  		    IS=MM+NSAM*(NN-1)
      		  		    B3DS(IS)=B3DS(IS)-SAMP
c      		  		    T3DS(IS)=T3DS(IS)-CTFV2
      		  		  ENDIF
c      		  		  TTD=TTD-CTFV2
      		  		ENDIF
      		  	ENDIF
40	    CONTINUE
30	CONTINUE
C
C$OMP BARRIER
C
      	DO 31 I=I2+1,I3
      	  DO 31 J=-JC+1,JC-1
           DO 31 BEAM=1,2                               ! insert both left and right beam if IEWALD
            IF ((IEWALD.EQ.0).AND.(BEAM.EQ.2)) GOTO 31  ! skip 2nd beam if planar insertion
            IF (IEWALD.EQ.0) THEN
      	      X3=DM(1)*I+DM(4)*J                        ! planar insertion
      	      Y3=DM(2)*I+DM(5)*J
      	      Z3=DM(3)*I+DM(6)*J
            ENDIF
      	    G2=I**2+J**2
      	    WGT=EXP(2.0*TMP*G2)
            PHASE=(SHX+DX)*I+(SHY+DY)*J
            PSHFT=CMPLX(COS(PHASE),SIN(PHASE))
      	    IF (I.GE.0) THEN
      	      II=I+1
      	      JJ=J+1
      	      IF (JJ.LT.1) JJ=JJ+NSAM
      	      IF (II.NE.JC) THEN
      		ID=II+NSAMH*(JJ-1)
      		CTFR=CTFF(ID)
      		CTFL=CTFF(ID+IC)
                IF (IEWALD.LT.0) THEN
                  CTFR=CONJG(CTFR)
                  CTFL=CONJG(CTFL)
                ENDIF
                SAMP=SPEC(ID)*PSHFT
                IF (IEWALD.NE.0) THEN 
                  IF (BEAM.EQ.1) THEN
                    CALL EWALDIN (NSAM,IRADA,C3DF,C3DS,SINCLUT,IPAD, ! reference-derived 
     +                    I,J,DM,THET,XYZ,FOR,FOL,SAMP,PREL,IEWALD,  ! structure factors 
     +                    CTFR,CTFL)
                    X3=XYZ(1)
                    Y3=XYZ(2)
                    Z3=XYZ(3)
                    SAMP=FOR                                         ! right beam
                  ELSE
                    X3=XYZ(4)
                    Y3=XYZ(5)
                    Z3=XYZ(6)
                    SAMP=FOL                                         ! left beam
                  ENDIF
                ELSE
                  SAMP=SAMP*(CTFR+CONJG(CTFL))
                ENDIF
      	      ELSE
                CTFR=CTFS(JJ)
                CTFL=CTFS(JJ+NSAM)
                IF (IEWALD.LT.0) THEN
                  CTFR=CONJG(CTFR)
                  CTFL=CONJG(CTFL)
                ENDIF
                SAMP=SPEQ(JJ)*PSHFT
                IF (IEWALD.NE.0) THEN 
                  IF (BEAM.EQ.1) THEN
                    CALL EWALDIN (NSAM,IRADA,C3DF,C3DS,SINCLUT,IPAD, ! outmost pixel
     +                    I,J,DM,THET,XYZ,FOR,FOL,SAMP,PREL,IEWALD,
     +                    CTFR,CTFL)
                    X3=XYZ(1)
                    Y3=XYZ(2)
                    Z3=XYZ(3)
                    SAMP=FOR                                         ! right beam
                  ELSE
                    X3=XYZ(4)
                    Y3=XYZ(5)
                    Z3=XYZ(6)
                    SAMP=FOL                                         ! left beam
                  ENDIF
                ELSE
                  SAMP=SAMP*(CTFR+CONJG(CTFL))
                ENDIF  
              ENDIF
            ELSE
              II=-I+1
              JJ=-J+1
              IF (JJ.LT.1) JJ=JJ+NSAM
              IF (II.NE.JC) THEN
                ID=II+NSAMH*(JJ-1)
       		CTFR=CTFF(ID)
       		CTFL=CTFF(ID+IC)
                IF (IEWALD.LT.0) THEN
                  CTFR=CONJG(CTFR)
                  CTFL=CONJG(CTFL)
                ENDIF
                SAMP=CONJG(SPEC(ID))*PSHFT
                IF (IEWALD.NE.0) THEN 
                  IF (BEAM.EQ.1) THEN
                    CALL EWALDIN (NSAM,IRADA,C3DF,C3DS,SINCLUT,IPAD, ! reference-derived 
     +                    I,J,DM,THET,XYZ,FOR,FOL,SAMP,PREL,IEWALD,  ! structure factors 
     +                    CTFR,CTFL)
                    X3=XYZ(1)
                    Y3=XYZ(2)
                    Z3=XYZ(3)
                    SAMP=FOR                                         ! right beam
                  ELSE
                    X3=XYZ(4)
                    Y3=XYZ(5)
                    Z3=XYZ(6)
                    SAMP=FOL                                         ! left beam
                  ENDIF
                ELSE
                  SAMP=SAMP*(CTFR+CONJG(CTFL))
                ENDIF
     	      ELSE
                CTFR=CTFS(JJ)
                CTFL=CTFS(JJ+NSAM)
                IF (IEWALD.LT.0) THEN
                  CTFR=CONJG(CTFR)
                  CTFL=CONJG(CTFL)
                ENDIF
		SAMP=CONJG(SPEQ(JJ))*PSHFT
                IF (IEWALD.NE.0) THEN 
                  IF (BEAM.EQ.1) THEN
                    CALL EWALDIN (NSAM,IRADA,C3DF,C3DS,SINCLUT,IPAD, ! outmost pixel
     +                    I,J,DM,THET,XYZ,FOR,FOL,SAMP,PREL,IEWALD,
     +                    CTFR,CTFL)
                    X3=XYZ(1)
                    Y3=XYZ(2)
                    Z3=XYZ(3)
                    SAMP=FOR                                         ! right beam,
                  ELSE
                    X3=XYZ(4)
                    Y3=XYZ(5)
                    Z3=XYZ(6)
                    SAMP=FOL                                         ! left beam
                  ENDIF
                ELSE
                  SAMP=SAMP*(CTFR+CONJG(CTFL))
                ENDIF  
      	      ENDIF
      	    ENDIF
      	    CTFV2=0.25*CABS(CTFR+CONJG(CTFL))**2*WGT
            SAMP=SAMP*WGT

            A=X3+0.5-REAL(IRAD-1)/2.0
      	    LS=INT(A)
      	    IF (A.LT.0.0) LS=LS-1
      	    IF (LS.LT.0) LS=0
            A=X3+REAL(IRAD)/2.0
      	    LT=INT(A)
      	    IF (A.LT.0.0) LT=LT-1
      	    IF (LT.GE.JC) LT=JC-1
            A=Y3+0.5-REAL(IRAD-1)/2.0
      	    MS=INT(A)
      	    IF (A.LT.0.0) MS=MS-1
      	    IF (MS.LE.-JC) MS=-JC+1
            A=Y3+REAL(IRAD)/2.0
      	    MT=INT(A)
      	    IF (A.LT.0.0) MT=MT-1
      	    IF (MT.GE.JC) MT=JC-1
            A=Z3+0.5-REAL(IRAD-1)/2.0
      	    NS=INT(A)
      	    IF (A.LT.0.0) NS=NS-1
      	    IF (NS.LE.-JC) NS=-JC+1
            A=Z3+REAL(IRAD)/2.0
      	    NT=INT(A)
      	    IF (A.LT.0.0) NT=NT-1
      	    IF (NT.GE.JC) NT=JC-1
      	    DO 41 L=LS,LT
      	      L2=L**2
      	      DO 41 M=MS,MT
      	        M2=M**2
      		DO 41 N=NS,NT
      	          N2=N**2
C  Do not use box transform (Chuck Sindelar, 26.9.2008)
C      		  boxftv=BOXFT_LUT(arg,SINCLUT)

      		  	JRAD2=L2+M2+N2
      		  	IF (JRAD2.LE.IRREC2) THEN

      	          		LL=L+1
      		  		MM=M+1
      		  		IF (MM.LT.1) MM=MM+NSAM
      		  		NN=N+1
      		  		IF (NN.LT.1) NN=NN+NSAM
C      		  		ctfv2s2=ctfv2*boxftv
C      		  		BSAMP=samp*boxftv
      		  		IF (ISIGN.GT.0) THEN

      		  		  IF (LL.NE.JC) THEN
      		  		    ID=LL+NSAMH*((MM-1)+NSAM*(NN-1))
      		  		    ID4=IPAD*(LL-1)+1+IPAD*NSAMH*((MM-1)
     .                                  +IPAD*NSAM*(NN-1))
      		  		    B3DF(ID)=B3DF(ID)+SAMP
      		  		    T3DF(ID)=T3DF(ID)+CTFV2
                                    NKSUM=NKSUM+1
                                    IF (NNSTAT.NE.0) THEN
                                      KSUM(ID)=KSUM(ID)+1
                                      VSUM(ID)=VSUM(ID)+CABS(SAMP)**2
				      PSUM(ID)=PSUM(ID)
     .                                       +PDIFF(SAMP,C3DF(ID4))
                                      ASUM(ID)=ASUM(ID)+CABS(SAMP)
                                    ENDIF
      		  		  ELSE
      		  		    IS=MM+NSAM*(NN-1)
      		  		    B3DS(IS)=B3DS(IS)+SAMP
      		  		    T3DS(IS)=T3DS(IS)+CTFV2
      		  		  ENDIF
      		  		  TTD=TTD+CTFV2

      		  		ELSE

      		  		  IF (LL.NE.JC) THEN
      		  		    ID=LL+NSAMH*((MM-1)+NSAM*(NN-1))
      		  		    B3DF(ID)=B3DF(ID)-SAMP
c      		  		    T3DF(ID)=T3DF(ID)-CTFV2
      		  		  ELSE
      		  		    IS=MM+NSAM*(NN-1)
      		  		    B3DS(IS)=B3DS(IS)-SAMP
c      		  		    T3DS(IS)=T3DS(IS)-CTFV2
      		  		  ENDIF
c      		  		  TTD=TTD-CTFV2
      		  		ENDIF
      		  	ENDIF
41	    CONTINUE
31	CONTINUE
C
      	RETURN
      	END

