C**************************************************************************
      REAL FUNCTION SIGMA2(NSAM,IRAD,AMAG,A3DF,A3DS,DATC,DATQ,
     +                 PHI,THETA,PSI,SHX,SHY,SINCLUT,IPAD,
     +                 IEWALD,THETATR,CTFF,CTFS,RBUF,RI2)
C**************************************************************************
C  Calculates real space correlation coefficient.
C  Uses functions PEXTRACT, RLFT3.
C  Used in LMAIN.
C**************************************************************************
      IMPLICIT NONE
C
      INTEGER NSAM,L,M,LL,MM,JC,ID,IPAD,IRAD,IB1,ID2
      INTEGER IB2,IB3,M2,IEWALD,NSAMH
      REAL SHX,SHY,PHASE,SUM1,SUM2,CCPART,SINCLUT(*)
      REAL PHI,THETA,PSI,AMAG,THETATR,RBUF(*),A,PI,RI2
      PARAMETER  (PI=3.1415926535897)
      COMPLEX PSHFT,A3DF(*),A3DS(*),CTFF(*),CTFS(*)
      COMPLEX DATC(*),DATQ(*),Z
C**************************************************************************
      IB1=NSAM*NSAM
      IB2=IB1+2*NSAM
      IB3=IB2+NSAM*NSAM
      NSAMH=NSAM/2
      JC=NSAMH+1
C
      CALL PEXTRACT(NSAM,IRAD,RBUF,RBUF(IB1+1),A3DF,
     +         A3DS,PHI,THETA,PSI,SINCLUT,IPAD,
     +         THETATR/AMAG,IEWALD,CTFF,CTFS)
      DO 222 L=1,JC
        LL=L-1
        DO 222 M=1,NSAM
          MM=M-1
          IF (MM.GE.JC) MM=MM-NSAM
          PHASE=-SHX*LL-SHY*MM
          PSHFT=CMPLX(COS(PHASE),SIN(PHASE))
          IF (L.NE.JC) THEN
            ID=L+NSAMH*(M-1)
            Z=PSHFT*DATC(ID)
            ID2=2*ID+IB2
            RBUF(ID2-1)=REAL(Z)
            RBUF(ID2)=AIMAG(Z)
          ELSE
            Z=PSHFT*DATQ(M)
            M2=2*M+IB3
            RBUF(M2-1)=REAL(Z)
            RBUF(M2)=AIMAG(Z)
          ENDIF
222   CONTINUE
      RBUF(IB2+1)=0.0
      RBUF(IB2+2)=0.0
      RBUF(1)=0.0
      RBUF(2)=0.0
      CALL RLFT3(RBUF(IB2+1),RBUF(IB3+1),NSAM,NSAM,1,-1)
      CALL RLFT3(RBUF,RBUF(IB1+1),NSAM,NSAM,1,-1)
C
      SUM1=0.0
      SUM2=0.0
      CCPART=0.0
      DO 223 L=1,NSAM*NSAM
        ID=IB2+L
        CCPART=CCPART+RBUF(L)*RBUF(ID)
        SUM1=SUM1+RBUF(L)**2
        SUM2=SUM2+RBUF(ID)**2
223   CONTINUE
C
      A=CCPART/SUM1
      SUM1=SQRT(SUM1)
      SUM2=SQRT(SUM2)
      SIGMA2=ABS(SUM2/A/SUM1-A*SUM1/SUM2)/RI2/PI
C
      RETURN
      END
